#ifndef DATAFLOW_HPP
#define DATAFLOW_HPP

#include "config.h"
#include <vector>
// some trickery to get uint64_t --- you would think the natural
// way to do this would be to check for csdtint in the configure
// script and then just include it, however, cstdint only works
// with -std=c++0x at the moment --- this would crush all hopes
// for portable code

#ifdef HAVE_STDINT_H
#include <stdint.h>
#endif
#ifdef HAVE_INTTYPES_H
#include <inttypes.h>
#endif
#include "HtorSets.hpp"


typedef struct {
    uint64_t start, sstart, id;
    int owner, sowner, peer, size, ssize;
    char mtype, smtype, type;
} tuple;


std::vector<tuple*>* DataFlowAnalysis(HtorSets* hs);

#endif

